<?php

function search_zeitungen($keyword)
{
  global $cfg;

  $query = sprintf("SELECT id,name,city FROM zeitungen WHERE deleted IS false AND " .
		   "( name ILIKE '%%%s%%' OR url ILIKE '%%%s%%' " .
		   "OR city ILIKE '%%%s%%' OR description ILIKE '%%%s%%') " .
		   "ORDER BY name",
		   pg_escape_string($keyword), pg_escape_string($keyword),
		   pg_escape_string($keyword), pg_escape_string($keyword));

  if (($sth = db_query($query)) === false) return array();

  if (pg_num_rows($sth) == 0) return array();

  $ret = array();
  for ($i=0; $i < pg_num_rows($sth); $i++) {
    $row = pg_fetch_array($sth, $i);

    $ret[] = sprintf('<a href="%szeitung/%d.html">%s</a>, %s',
		     $cfg['basepath'], $row['id'], $row['name'], $row['city']);
  }

  return $ret;
}

function search_tags($keyword)
{
  global $cfg;

  $query = sprintf("SELECT tagname FROM tags WHERE " .
		   "tagname ILIKE '%%%s%%' " .
		   "ORDER BY lower(tagname)",
		   pg_escape_string($keyword));

  if (($sth = db_query($query)) === false) return array();

  if (pg_num_rows($sth) == 0) return array();

  $ret = array();
  for ($i=0; $i < pg_num_rows($sth); $i++) {
    $row = pg_fetch_array($sth, $i);

    $ret[] = sprintf('Tag <a href="%stag/%s.html">%s</a>',
		     $cfg['basepath'], urlencode($row['tagname']),
		     $row['tagname']);
  }

  return $ret;
}

function search_topics($keyword)
{
  global $cfg;

  $query = sprintf("SELECT id,topic FROM topics WHERE " .
		   "topic ILIKE '%%%s%%' ORDER BY topic",
		   pg_escape_string($keyword));

  if (($sth = db_query($query)) === false) return array();

  if (pg_num_rows($sth) == 0) return array();

  $ret = array();
  for ($i=0; $i < pg_num_rows($sth); $i++) {
    $row = pg_fetch_array($sth, $i);

    $ret[] = sprintf('Diskussion <a href="%stopic/%d.html">%s</a>',
		     $cfg['basepath'], $row['id'], 
		     $row['topic']);
  }

  return $ret;
}

function process_search()
{
  global $zlist;

  if (!strlen($_POST['keyword']))
    $ret = warning('Sie haben keinen Suchbegriff angegeben!');
  else {
    $results = array_merge(search_zeitungen($_POST['keyword']),
			   search_tags($_POST['keyword']),
			   search_topics($_POST['keyword']));

    if (count($results)) {
      $ret = '<ul class="gold">';
      foreach ($results as $res) {
	$ret .= '<li>' . $res;
      }
      $ret .= '</ul>';
    } else {
      $zlist['keyword'] = htmlspecialchars($_POST['keyword']);
      $ret = information(sprintf('Keine Treffer für "%s" gefunden.', $zlist['keyword']));
    }
  }

  return $ret;
}

function ajax_search_check()
{
  $keyword = $_POST['keyword'];

  $query = sprintf("SELECT count(*) FROM zeitungen WHERE deleted IS false AND " .
		   "( name ILIKE '%%%s%%' OR url ILIKE '%%%s%%' " .
		   "OR city ILIKE '%%%s%%' OR description ILIKE '%%%s%%') ",
		   pg_escape_string($keyword), pg_escape_string($keyword),
		   pg_escape_string($keyword), pg_escape_string($keyword));

  if (($sth = db_query($query)) !== false) {
    $row = pg_fetch_array($sth, 0);
    if ($row[0] > 0)
      return true;
  }

  $query = sprintf("SELECT count(*) FROM tags WHERE " .
		   "tagname ILIKE '%%%s%%' ",
		   pg_escape_string($keyword));

  if (($sth = db_query($query)) !== false) {
    $row = pg_fetch_array($sth, 0);
    if ($row[0] > 0)
      return true;
  }

  $query = sprintf("SELECT count(*) FROM topics WHERE " .
		   "topic ILIKE '%%%s%%'",
		   pg_escape_string($keyword));

  if (($sth = db_query($query)) !== false) {
    $row = pg_fetch_array($sth, 0);
    if ($row[0] > 0)
      return true;
  }

  return false;
}
